// Autogenerated from Pigeon (v17.3.0), do not edit directly.
// See also: https://pub.dev/packages/pigeon

import Foundation

#if os(iOS)
  import Flutter
#elseif os(macOS)
  import FlutterMacOS
#else
  #error("Unsupported platform.")
#endif

private func wrapResult(_ result: Any?) -> [Any?] {
  return [result]
}

private func wrapError(_ error: Any) -> [Any?] {
  if let flutterError = error as? FlutterError {
    return [
      flutterError.code,
      flutterError.message,
      flutterError.details,
    ]
  }
  return [
    "\(error)",
    "\(type(of: error))",
    "Stacktrace: \(Thread.callStackSymbols)",
  ]
}

private func isNullish(_ value: Any?) -> Bool {
  return value is NSNull || value == nil
}

private func nilOrValue<T>(_ value: Any?) -> T? {
  if value is NSNull { return nil }
  return value as! T?
}

/// Generated protocol from Pigeon that represents a handler of messages from Flutter.
protocol SimpleFileSaverApi {
  func saveFile(dataBytes: FlutterStandardTypedData, fileName: String, completion: @escaping (Result<Bool, Error>) -> Void)
  func saveFileAs(dataBytes: FlutterStandardTypedData, fileName: String, completion: @escaping (Result<Bool, Error>) -> Void)
}

/// Generated setup class from Pigeon to handle messages through the `binaryMessenger`.
class SimpleFileSaverApiSetup {
  /// The codec used by SimpleFileSaverApi.
  /// Sets up an instance of `SimpleFileSaverApi` to handle messages through the `binaryMessenger`.
  static func setUp(binaryMessenger: FlutterBinaryMessenger, api: SimpleFileSaverApi?) {
    let saveFileChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.simple_file_saver_ios.SimpleFileSaverApi.saveFile", binaryMessenger: binaryMessenger)
    if let api = api {
      saveFileChannel.setMessageHandler { message, reply in
        let args = message as! [Any?]
        let dataBytesArg = args[0] as! FlutterStandardTypedData
        let fileNameArg = args[1] as! String
        api.saveFile(dataBytes: dataBytesArg, fileName: fileNameArg) { result in
          switch result {
          case .success(let res):
            reply(wrapResult(res))
          case .failure(let error):
            reply(wrapError(error))
          }
        }
      }
    } else {
      saveFileChannel.setMessageHandler(nil)
    }
    let saveFileAsChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.simple_file_saver_ios.SimpleFileSaverApi.saveFileAs", binaryMessenger: binaryMessenger)
    if let api = api {
      saveFileAsChannel.setMessageHandler { message, reply in
        let args = message as! [Any?]
        let dataBytesArg = args[0] as! FlutterStandardTypedData
        let fileNameArg = args[1] as! String
        api.saveFileAs(dataBytes: dataBytesArg, fileName: fileNameArg) { result in
          switch result {
          case .success(let res):
            reply(wrapResult(res))
          case .failure(let error):
            reply(wrapError(error))
          }
        }
      }
    } else {
      saveFileAsChannel.setMessageHandler(nil)
    }
  }
}
